ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.44 by root, Tue Jul 24 04:55:35 2007 UTC vs.
Revision 1.109 by root, Wed Oct 20 15:55:07 2010 UTC

1#!@PERL@ 1#!@PERL@
2 2
3use strict; 3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009,2010 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
24
25use common::sense;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
12my $OPTIPNG = "@OPTIPNG@"; 34my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@"; 36my $PNGNQ = "@PNGNQ@";
15 37
16use Getopt::Long; 38use Getopt::Long;
39use File::Temp;
40use POSIX ();
41use Carp;
42
17use Coro::Event; 43use Coro::EV;
18use AnyEvent; 44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
19use IO::AIO (); 47use IO::AIO ();
20use File::Temp; 48use Digest::MD5 ();
21use Crossfire; 49
22use Coro; 50use Coro 5.12;
23use Coro::AIO; 51use Coro::AIO;
24use POSIX (); 52use Coro::Util;
25use Digest::MD5; 53use Coro::Channel;
26use Carp;
27use Coro::Storable; $Storable::canonical = 1; 54use Coro::Storable; $Storable::canonical = 1;
55
56use Deliantra;
28 57
29$SIG{QUIT} = sub { Carp::cluck "QUIT" }; 58$SIG{QUIT} = sub { Carp::cluck "QUIT" };
30 59
31sub usage { 60sub usage {
32 warn <<EOF; 61 warn <<EOF;
45my $VERBOSE = 1; 74my $VERBOSE = 1;
46my $CACHE = 0; 75my $CACHE = 0;
47my $FORCE; 76my $FORCE;
48my $TMPDIR = "/tmp/cfutil$$~"; 77my $TMPDIR = "/tmp/cfutil$$~";
49my $TMPFILE = "aaaa0"; 78my $TMPFILE = "aaaa0";
79my @COMMIT;
50 80
51our %COLOR = ( 81our %COLOR = (
82 # original cf colours
52 black => 0, 83 black => 0,
53 white => 1, 84 white => 1,
54 navy => 2, 85 navy => 2, # "dark blue"
55 red => 3, 86 red => 3,
56 orange => 4, 87 orange => 4,
57 blue => 5, 88 blue => 5, # "light blue"
58 darkorange => 6, 89 darkorange => 6,
59 green => 7, 90 green => 7,
60 lightgreen => 8, 91 lightgreen => 8,
61 grey => 9, 92 grey => 9,
93 brown => 10, # "yellow"
94 gold => 11, # "light yellow"
95 tan => 12, # yellowish gray
96
97 # new for deliantra
62 brown => 10, 98 none => 13,
99
100 # compatibility to existing archetypes
101 lightblue => 5,
63 gold => 11, 102 gray => 9,
103 yellow => 11,
64 tan => 12, 104 khaki => 12,
65); 105);
66 106
67END { system "rm", "-rf", $TMPDIR } 107END { system "rm", "-rf", $TMPDIR }
68 108
69Event->signal (signal => "INT", cb => sub { exit 1 }); 109my $s_INT = EV::signal INT => sub { exit 1 };
70Event->signal (signal => "TERM", cb => sub { exit 1 }); 110my $s_TERM = EV::signal TERM => sub { exit 1 };
111
112our %hash;
113
114# here we could try to avoid collisions and reduce chksum size further
115sub make_hash($\$\$;$) {
116 my ($id, $dataref, $hashref, $clen) = @_;
117
118 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
119
120 if (exists $hash{$hash}) {
121 # hash collision, but some files are simply identical
122 if (${$hash{$hash}[1]} ne $$dataref) {
123 warn "hash collision $hash{$hash}[0] vs. $id\n";
124 exit 1;
125 } else {
126 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
127 }
128 }
129 $hash{$hash} = [$id, $dataref, $hashref];
130
131 $$hashref = $hash;
132}
71 133
72mkdir $TMPDIR, 0700 134mkdir $TMPDIR, 0700
73 or die "$TMPDIR: $!"; 135 or die "$TMPDIR: $!";
74 136
75sub fork_sub(&) { 137sub fork_sub(&) {
95 if (!-f "$path/regions") { 157 if (!-f "$path/regions") {
96 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 158 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
97 exit 1 unless $FORCE; 159 exit 1 unless $FORCE;
98 } 160 }
99 161
100 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded" 162 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
163 "$path/.", "$DATADIR/maps/.",
164 "--exclude", "CVS", "--exclude", "/world-precomposed",
165 "--delete", "--delete-excluded"
101 and die "map installation failed.\n"; 166 and die "map installation failed.\n";
102 167
103 print "maps installed successfully.\n"; 168 print "maps installed successfully.\n";
104} 169}
105 170
113 our $NFILE; 178 our $NFILE;
114 our $PATH; 179 our $PATH;
115 180
116 our $QUANTIZE = "+dither -colorspace RGB -colors 256"; 181 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
117 182
118 our (@png, @trs, @arc, @res); # files we are interested in 183 our $c_arc = new Coro::Channel;
184 our $c_any = new Coro::Channel;
119 185
186 our @c_png;
187
120 sub commit_png($$$) { 188 sub commit_png($$$$) {
121 my ($name, $data, $T) = @_; 189 my ($stem, $name, $data, $T) = @_;
122 190
191 $FACEINFO{$name}{"stem"} = substr $stem, 1 + length $PATH;
123 $FACEINFO{$name}{"data$T"} = $data; 192 $FACEINFO{$name}{"data$T"} = $data;
124 } 193 }
125 194
126 sub process_png { 195 sub process_png {
127 while (@png) { 196 while (@c_png) {
128 my ($path, $delete) = @{pop @png}; 197 my ($path, $delete) = @{pop @c_png};
129 198
130 my $png; 199 my $png;
131 aio_lstat $path; 200 aio_lstat $path;
132 my ($size, $mtime) = (stat _)[7,9]; 201 my ($size, $mtime) = (stat _)[7,9];
133 202
164 if ($w % $T || $h % $T) { 233 if ($w % $T || $h % $T) {
165 warn "$path: weird png size ($w $h), skipping.\n"; 234 warn "$path: weird png size ($w $h), skipping.\n";
166 next; 235 next;
167 } 236 }
168 237
238 (my $base = $stem) =~ s/^.*\///;
239
240 my $fi = $FACEINFO{$base};
241 unless ($fi) {
242 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
243 #next;
244 }
245
246 my $arc = $fi->{arc} || { };
247
169 unless ($path =~ /~$/) { 248 unless ($path =~ /~$/) {
170 # possibly enlarge 249 # possibly enlarge
171 if (0 > aio_stat "$stem.64x64.png") { 250 if (0 > aio_stat "$stem.64x64.png") {
172 my $other = "$stem.64x64.png~"; 251 my $other = "$stem.64x64.png~";
173 252
174 if (0 > aio_lstat $other or (-M _) > (-M $path)) { 253 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
175 my $wrap = 0; # for the time being
176 fork_sub { 254 fork_sub {
255 my $CROP;
256 my $SRC = "png:\Q$path\E";
257
258 my $is_floor = $arc->{is_floor};
259 my $is_wall = 0;
260
261 my ($wall_pfx, $wall_dir, $wall_sfx);
262
263 if (
264 !$is_floor
265 && !$arc->{alive}
266 && $arc->{move_block} eq "all"
267 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
268 ) {
269 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
270
271 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
272 $is_wall = 1;
273 }
274 }
275
276 if ($is_wall || $is_floor) {
277 # add a 4px border and add other images around it
278 $CROP = "-shave 8x8 +repage";
279
280 $w += 8;
281 $h += 8;
282
283 $SRC = "-size ${w}x${h} xc:transparent";
284 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
285
286 # 8 surrounding images
287 for (
288 # x y b r0 r1
289 [-1, -1, 0, 6],
290 [ 0, -1, 1, 10, 14],
291 [+1, -1, 0, 12],
292
293 [-1, 0, 8, 5, 7],
294 #
295 [+1, 0, 2, 5, 13],
296
297 [-1, +1, 0, 3],
298 [ 0, +1, 4, 10, 11],
299 [+1, +1, 0, 9],
300 ) {
301 my ($x, $y, $d, $r0, $r1) = @$_;
302
303 my $tile = $is_floor ? $path
304 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
305 : die;
306
307 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
308 "\Q$tile",
309 $x * ($w - 8) + 4,
310 $y * ($h - 8) + 4;
311 }
312 }
313
177 system "convert png:\Q$path\E -depth 8 rgba:-" 314 system "convert -depth 8 $SRC rgba:-"
178 . "| $exec_prefix/bin/cfhq2xa $w $h $wrap" 315 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
179 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $QUANTIZE -quality 00 png32:\Q$other\E~" 316 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
180 and die "convert/hq2xa pipeline error: status $? ($!)"; 317 and die "convert/cfhq2xa pipeline error: status $? ($!)";
181 system $OPTIPNG, "-i0", "-q", "$other~"; 318 system $OPTIPNG, "-i0", "-q", "$other~";
182 die "$other~ has zero size, aborting." unless -s "$other~"; 319 die "$other~ has zero size, aborting." unless -s "$other~";
183 rename "$other~", $other; 320 rename "$other~", $other;
184 }; 321 };
185 } 322 }
186 323
187 push @png, [$other, !$CACHE]; 324 push @c_png, [$other, !$CACHE];
188 } 325 }
189 326
190 # possibly scale down 327 # possibly scale down
191 if (0 > aio_stat "$stem.32x32.png") { 328 if (0 > aio_stat "$stem.32x32.png") {
192 my $other = "$stem.32x32.png~"; 329 my $other = "$stem.32x32.png~";
195 fork_sub { 332 fork_sub {
196 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~"; 333 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
197 system $OPTIPNG, "-i0", "-q", "$other~"; 334 system $OPTIPNG, "-i0", "-q", "$other~";
198 335
199 # reduce smoothfaces >10000 bytes 336 # reduce smoothfaces >10000 bytes
337 # obsolete, no longer required
200 if ($stem =~ /_S\./ && (-s "$other~") > 10000) { 338 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
201 my $ncolor = 256; 339 my $ncolor = 256;
202 while () { 340 while () {
203 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E"; 341 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
204 system $OPTIPNG, "-i0", "-q", "$other~~"; 342 system $OPTIPNG, "-i0", "-q", "$other~~";
205 last if 10000 > -s "$other~~"; 343 last if 10000 > -s "$other~~";
217 rename "$other~", $other; 355 rename "$other~", $other;
218 }; 356 };
219 } 357 }
220 358
221 #warn "scaled down $path to $other\n";#d# 359 #warn "scaled down $path to $other\n";#d#
222 push @png, [$other, !$CACHE]; 360 push @c_png, [$other, !$CACHE];
223 } 361 }
224 } 362 }
225 363
226 (my $face = $stem) =~ s/^.*\///; 364 (my $face = $stem) =~ s/^.*\///;
227 365
276 414
277 if (0 > aio_load $file, $tile) { 415 if (0 > aio_load $file, $tile) {
278 die "$path: unable to read tile +$x+$y, aborting.\n"; 416 die "$path: unable to read tile +$x+$y, aborting.\n";
279 } 417 }
280 IO::AIO::aio_unlink $file unless $CACHE; 418 IO::AIO::aio_unlink $file unless $CACHE;
281 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T; 419 commit_png $stem, $x|$y ? "$face+$x+$y" : $face, $tile, $T;
282 } 420 }
283 } else { 421 } else {
284 # use as-is (either small, use smooth) 422 # use as-is (either small, use smooth)
285 commit_png $face, $png, $T; 423 commit_png $stem, $face, $png, $T;
286 } 424 }
287 425
288 aio_unlink $path if $delete; 426 aio_unlink $path if $delete;
289 } 427 }
290 } 428 }
291 429
430 sub process_faceinfo {
431 my ($dir, $file) = @_;
432 my $path = "$dir/$file";
433
434 my $data;
435 if (0 > aio_load $path, $data) {
436 warn "$path: $!, skipping.\n";
437 return;
438 }
439
440 for (split /\n/, $data) {
441 chomp;
442 my ($face, $visibility, $fg, $bg, $glyph) = split /\s+/, $_, 5;
443 # bg not used except for text clients
444
445 utf8::decode $glyph;
446 $glyph =~ s/^\?(?=.)//; # remove "autoglyph" flag
447
448 $fg = "white" if $fg eq "none"; # lots of faces have no fg colour yet
449
450 (my $fgi = $COLOR{$fg})
451 // warn "WARNING: $path: $face specifies unknown foreground colour '$fg'.\n";
452 (my $bgi = $COLOR{$bg})
453 // warn "WARNING: $path: $face specifies unknown background colour '$bg'.\n";
454
455 my $fi = $FACEINFO{$face} ||= { };
456 $fi->{visibility} = $visibility * 1;
457 $fi->{magicmap} = $fgi; # foreground colour becomes magicmap
458
459 $glyph .= " " if 2 > length $glyph; # TODO kanji
460 die "glyph $face too long" if 2 < length $glyph;
461
462 $fi->{glyph} = "";
463 for (split //, $glyph) {
464 utf8::encode $_;
465 $fi->{glyph} .= (chr $fgi) . (chr $bgi) . $_;
466 }
467 }
468 }
469
292 sub process_arc { 470 sub process_arc {
293 while (@arc) { 471 while (my ($dir, $file) = @{ $c_arc->get }) {
294 my ($dir, $file) = @{pop @arc};
295
296 my $arc; 472 my $arc;
297 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 473 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
298 474
299 my $arc = read_arch "$dir/$file"; 475 my $arc = read_arch "$dir/$file";
300 for my $o (values %$arc) { 476 for my $o (values %$arc) {
301 push @ARC, $o; 477 push @ARC, $o;
302 for (my $m = $o; $m; $m = $m->{more}) { 478 for (my $m = $o; $m; $m = $m->{more}) {
303 $ARC{$m->{_name}} = $m; 479 $ARC{$m->{_name}} = $m;
304 } 480 }
305 481
306 $o->{editor_folder} = $dir; 482 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
307
308 my $visibility = delete $o->{visibility};
309 my $magicmap = delete $o->{magicmap};
310 483
311 # find upper left corner :/ 484 # find upper left corner :/
312 # omg, this is sooo broken 485 # omg, this is sooo broken
313 my ($dx, $dy); 486 my ($dx, $dy);
314 for (my $o = $o; $o; $o = $o->{more}) { 487 for (my $o = $o; $o; $o = $o->{more}) {
321 my $y = $o->{y} - $dy; 494 my $y = $o->{y} - $dy;
322 495
323 my $ext = $x|$y ? "+$x+$y" : ""; 496 my $ext = $x|$y ? "+$x+$y" : "";
324 497
325 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face}; 498 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
326
327 $visibility = delete $o->{visibility} if exists $o->{visibility};
328 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
329 499
330 my $anim = delete $o->{anim}; 500 my $anim = delete $o->{anim};
331 501
332 if ($anim) { 502 if ($anim) {
333 # possibly add $ext to the animation name to avoid 503 # possibly add $ext to the animation name to avoid
351 facings => $facings, 521 facings => $facings,
352 frames => \@frames, 522 frames => \@frames,
353 }; 523 };
354 } 524 }
355 525
356 for my $face ($o->{face} || (), @{$anim || []}) { 526 for ($o->{face} || (), @{$anim || []}) {
357 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 527 next if /^facings\s/;
358 528
529 my $face = $_;
530 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
531
359 my $info = $FACEINFO{$face} ||= {}; 532 my $info = $FACEINFO{$face} ||= { };
533 $info->{arc} = $o;
360 534
361 $info->{visibility} = $visibility if defined $visibility; 535 next if $face =~ /^blank.x11$|^empty.x11$/;
362 $info->{magicmap} = $magicmap if defined $magicmap;
363 } 536 }
364 537
365 if (my $smooth = delete $o->{smoothface}) { 538 if (my $smooth = delete $o->{smoothface}) {
366 my %kv =split /\s+/, $smooth; 539 my %kv = split /\s+/, $smooth;
367 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support 540 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
368 while (my ($face, $smooth) = each %kv) { 541 while (my ($face, $smooth) = each %kv) {
542 $FACEINFO{$smooth}{arc} = $o;
543
369 $FACEINFO{$face}{smooth} = $smooth; 544 $FACEINFO{$face}{smooth} = $smooth;
370 $FACEINFO{$face}{smoothlevel} = $level; 545 $FACEINFO{$face}{smoothlevel} = $level;
371 } 546 }
372 } 547 }
373 } 548 }
374 } 549 }
375 } 550 }
376 } 551 }
377 552
378 sub process_trs { 553 sub process_trs {
379 while (@trs) {
380 my ($dir, $file) = @{pop @trs}; 554 my ($dir, $file) = @_;
381 my $path = "$dir/$file"; 555 my $path = "$dir/$file";
382 556
383 my $trs; 557 my $trs;
384 if (0 > aio_load $path, $trs) { 558 if (0 > aio_load $path, $trs) {
385 warn "$path: $!, skipping.\n"; 559 warn "$path: $!, skipping.\n";
386 next; 560 return;
387 } 561 }
388 562
389 $TRS .= $trs; 563 $TRS .= $trs;
564 }
565
566 my %FILECACHE;
567
568 sub load_cached($;$) {
569 unless (exists $FILECACHE{$_[0]}) {
570 my $data;
571 if (0 < aio_load $_[0], $data) {
572 if ($_[1]) {
573 $data = eval { $_[1]->($data) };
574 warn "$_[0]: $@" if $@;
575 }
390 } 576 }
577
578 $FILECACHE{$_[0]} = $data;
579 }
580
581 $FILECACHE{$_[0]}
391 } 582 }
392 583
393 sub process_res { 584 sub process_res {
394 while (@res) {
395 my ($dir, $file, $type) = @{pop @res}; 585 my ($dir, $file, $type) = @_;
396 586
397 my $data; 587 my $data;
398 aio_load "$dir/$file", $data; 588 aio_load "$dir/$file", $data;
399 589
400 my $copyright; 590 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
401 aio_load "$dir/copyright", $copyright;
402 591
592 utf8::decode $dir;
593 utf8::decode $file;
594
595 # a meta file for resources is now mandatory
596 unless (exists $meta->{$file}) {
597 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
598 return;
599 }
600
601 $meta = {
602 %{ $meta->{"" } || {} },
603 %{ $meta->{$file} || {} },
604 };
605
606 if ($meta->{license} =~ s/^#//) {
607 $meta->{license} = ({
608 "pd" => "Public Domain",
609 "gpl" => "GNU General Public License, version 3.0 or any later",
610 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
611 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
612 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
613 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
614 })->{$meta->{license}}
615 || warn "$dir/$file: license tag '$meta->{license}' not found.";
616 }
617
618 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
619 ($meta->{author} = $1) =~ s/_/ /g;
620 }
621
403 $file =~ s/\.res$//; 622 $file =~ s/\.res$//;
404 $file =~ /\.([^.]+)$/ 623 $file =~ s/\.(ogg|wav|jpg|png)$//;
405 or next;
406 624
407 substr $dir, 0, 1 + length $PATH, ""; 625 substr $dir, 0, 1 + length $PATH, "";
408 626
627 if (my $filter = $meta->{cfutil_filter}) {
628 if ($filter eq "yaml2json") {
629 $data = JSON::XS::encode_json YAML::XS::Load $data;
630 } elsif ($filter eq "json2json") {
631 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
632 } elsif ($filter eq "perl2json") {
633 $data = eval $data; die if $@;
634 $data = JSON::XS::encode_json $data;
635 } else {
636 warn "$dir/$file: unknown filter $filter, skipping\n";
637 }
638 }
639
409 $RESOURCE{"$dir/$file"} = { 640 $RESOURCE{"$dir/$file"} = {
410 type => $type, 641 type => (exists $meta->{type} ? delete $meta->{type} : $type),
411 copyright => $copyright,
412 data => $data, 642 data => $data,
413 chksum => Digest::MD5::md5 $data, 643 %$meta ? (meta => $meta) : (),
414 }; 644 };
645 }
646
647 sub process_any {
648 while (my ($func, @args) = @{ $c_any->get }) {
649 $func->(@args);
415 } 650 }
416 } 651 }
417 652
418 sub find_files; 653 sub find_files;
419 sub find_files { 654 sub find_files {
420 my ($path) = @_; 655 my ($path) = @_;
421 656
657 my $grp = IO::AIO::aio_group;
658
659 my $scandir; $scandir = sub {
660 my ($path) = @_;
661
422 IO::AIO::aioreq_pri 4; 662 IO::AIO::aioreq_pri 4;
423 IO::AIO::aio_scandir $path, 4, sub { 663 add $grp IO::AIO::aio_scandir $path, 4, sub {
424 my ($dirs, $nondirs) = @_; 664 my ($dirs, $nondirs) = @_;
425 665
426 find_files "$path/$_" 666 $scandir->("$path/$_")
427 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 667 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
428 668
429 my $dir = $path; 669 my $dir = $path;
430 substr $dir, 0, 1 + length $PATH, ""; 670 substr $dir, 0, 1 + length $PATH, "";
431 671
432 for my $file (@$nondirs) { 672 for my $file (@$nondirs) {
433 if ($dir =~ /^music(?:\/|$)/) { 673 if ($dir =~ /^music(?:\/|$)/) {
434 push @res, [$path, $file, 3] # FT_MUSIC 674 $c_any->put ([\&process_res, $path, $file, 3]) # FT_MUSIC
435 if $file =~ /\.(ogg)$/; 675 if $file =~ /\.(ogg)$/;
436 676
437 } elsif ($dir =~ /^sounds(?:\/|$)/) { 677 } elsif ($dir =~ /^sound(?:\/|$)/) {
438 push @res, [$path, $file, 5] # FT_SOUND 678 $c_any->put ([\&process_res, $path, $file, 5]) # FT_SOUND
439 if $file =~ /\.(wav|ogg)$/; 679 if $file =~ /\.(wav|ogg)$/;
440 680
441 } elsif ($dir =~ /^res(?:\/|$)/) { 681 } elsif ($dir =~ /^res(?:\/|$)/) {
442 push @res, [$path, $file, 0] # FT_FACE
443 if $file =~ /\.(jpg|png)$/; 682 if ($file =~ /\.(jpg|png)$/) {
444 push @res, [$path, $file, 7] # FT_RSRC 683 $c_any->put ([\&process_res, $path, $file, 0]) # FT_FACE
445 if $file =~ /\.(res)$/; 684 } elsif ($file =~ /\.(res)$/) {
685 $c_any->put ([\&process_res, $path, $file, 6]) # FT_RSRC
686 } else {
687 $c_any->put ([\&process_res, $path, $file, undef]);
688 }
446 689
447 } elsif ($file =~ /\.png$/) { 690 } elsif ($file =~ /\.png$/) {
448 push @png, ["$path/$file", 0]; 691 push @c_png, ["$path/$file", 0];
449 692
693 } elsif ($file =~ /\.faceinfo$/) {
694 $c_any->put ([\&process_faceinfo, $path, $file]);
695
450 } elsif ($file =~ /\.trs$/) { 696 } elsif ($file =~ /\.trs$/) {
451 push @trs, [$path, $file]; 697 $c_any->put ([\&process_trs, $path, $file]);
452 698
453 } elsif ($file =~ /\.arc$/) { 699 } elsif ($file =~ /\.arc$/) {
454 push @arc, [$path, $file]; 700 $c_arc->put ([$path, $file]);
455 701
456 } else { 702 } else {
457 warn "ignoring $path/$file\n" if $VERBOSE >= 3; 703 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
458 } 704 }
705 }
459 } 706 };
460 }; 707 };
708
709 $scandir->($path);
710 aio_wait $grp;
711 }
712
713 sub generate_plurals {
714# use Lingua::EN::Inflect ();
715# Lingua::EN::Inflect::classical;
716# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
717# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
718#
719# for my $a (@ARC) {
720# my $name = $a->{name} || $a->{_name};
721#
722# next unless $a->{name_pl};
723# next if $a->{invisible};
724# next if $a->{is_floor};
725# next if $a->{no_pick};
726#
727# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
728# my $pl = $test =~ /^(?:eq|p:.)$/
729# ? $name
730# : Lingua::EN::Inflect::PL $name;
731#
732# if ($pl ne $a->{name_pl}) {
733# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
734# }
735# }
461 } 736 }
462 737
463 sub inst_arch($) { 738 sub inst_arch($) {
464 my (undef, $path) = @_; 739 my (undef, $path) = @_;
465 740
478 if (!-d "$path/treasures") { 753 if (!-d "$path/treasures") {
479 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 754 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
480 exit 1 unless $FORCE; 755 exit 1 unless $FORCE;
481 } 756 }
482 757
758 print "start file scan, arc, any processing...\n" if $VERBOSE;
759
760 my @a_arc = map +(async \&process_arc), 1..2;
761 my @a_any = map +(async \&process_any), 1..4;
762
483 find_files $path; 763 find_files $path;
484 IO::AIO::flush;
485 764
486 $_->join for ( 765 $c_arc->shutdown;
766 $c_any->shutdown;
767
768 $_->join for @a_arc; # need to parse all archetypes before png processing
769
770 print "end arc, start png processing...\n" if $VERBOSE;
771
487 # four png crunchers work fine for my 2x smp machine 772 # eight png crunchers work fine for my 4x smp machine
488 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png), 773 my @a_png = map +(async \&process_png), 1..8;
489 (async \&process_trs), (async \&process_trs),
490 (async \&process_arc), (async \&process_arc),
491 (async \&process_res), (async \&process_res),
492 );
493 774
775 print "end any processing...\n" if $VERBOSE;
776 $_->join for @a_any;
777
778 print "end png processing...\n" if $VERBOSE;
779 $_->join for @a_png;
780
781 print "scanning done, processing results...\n" if $VERBOSE;
494 { 782 {
495 # remove path prefix from editor_folder 783 # remove path prefix from editor_folder
784 $_->{editor_folder} =~ /^\x00/
496 substr $_->{editor_folder}, 0, 1 + length $path, "" 785 and substr $_->{editor_folder}, 0, 2 + length $path, ""
497 for values %ARC; 786 for values %ARC;
498 787
788 print "resolving inheritance tree...\n" if $VERBOSE;
499 # resolve inherit 789 # resolve inherit
500 while () { 790 while () {
501 my $progress; 791 my $progress;
502 my $loop; 792 my $loop;
503 793
504 for my $o (values %ARC) { 794 for my $o (values %ARC) {
505 if (my $other = $o->{inherit}) { 795 for my $other (split /,/, $o->{inherit}) {
506 if (my $s = $ARC{$other}) { 796 if (my $s = $ARC{$other}) {
507 if ($s->{inherit}) { 797 if ($s->{inherit}) {
508 $loop = $s; 798 $loop = $s;
509 } else { 799 } else {
510 delete $o->{inherit}; 800 delete $o->{inherit};
512 delete @s{qw(_name more name name_pl)}; 802 delete @s{qw(_name more name name_pl)};
513 %$o = ( %s, %$o ); 803 %$o = ( %s, %$o );
514 ++$progress; 804 ++$progress;
515 } 805 }
516 } else { 806 } else {
517 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n"; 807 warn "WARNING: archetype '$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
518 delete $ARC{$o->{_name}}; 808 delete $ARC{$o->{_name}};
519 } 809 }
520 } 810 }
521 } 811 }
522 812
529 } 819 }
530 820
531 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit 821 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
532 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC; 822 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
533 823
824 # fix up archetypes without names, where the archanme doesn't work at all
825 for (@ARC) {
826 if (!exists $_->{name} and $_->{_name} =~ /_/) {
827 for ($_->{name} = $_->{_name}) {
828 s/(?:_\d+)+$//;
829 s/_[nesw]+$//;
830 y/_/ /;
831 }
832 }
833 }
834
835 #print "generating plurals...\n" if $VERBOSE;
836 #generate_plurals;
837
838 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
534 open my $fh, ">:utf8", "$DATADIR/archetypes~" 839 open my $fh, ">:utf8", "$DATADIR/archetypes~"
535 or die "$DATADIR/archetypes~: $!"; 840 or die "$DATADIR/archetypes~: $!";
536 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC]; 841 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
537 } 842 }
538 843
539 { 844 {
845 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
540 open my $fh, ">:utf8", "$DATADIR/treasures~" 846 open my $fh, ">:utf8", "$DATADIR/treasures~"
541 or die "$DATADIR/treasures~: $!"; 847 or die "$DATADIR/treasures~: $!";
542 print $fh $TRS; 848 print $fh $TRS;
543 } 849 }
544 850
545 { 851 {
852 print "processing facedata...\n" if $VERBOSE;
546 while (my ($k, $v) = each %FACEINFO) { 853 while (my ($k, $v) = each %FACEINFO) {
547 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n"; 854 length $v->{data32} or warn "WARNING: face '$k' has no png32. this will not work (shoddy gcfclient will crash of course).\n";
548 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n"; 855 length $v->{data64} or warn "WARNING: face '$k' has no png64. this will not work very well.\n";
549 856
857 make_hash $k, $v->{data32}, $v->{hash32};
858 make_hash $k, $v->{data64}, $v->{hash64};
859
550 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n"; 860 #length $v->{data32} <= 10000 or warn "WARNING: face '$k' has face32 larger than 10000 bytes, will not work with crossfire client.\n";
551 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n"; 861 #length $v->{data64} <= 10000 or warn "WARNING: face '$k' has face64 larger than 10000 bytes.\n";
552 862
553 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 863 $v->{glyph} // warn "WARNING: face '$k' has glyph.";
554 $v->{chksum64} = Digest::MD5::md5 $v->{data64}; 864 $v->{visibility} // warn "WARNING: face '$k' has no visibility info, missing faceinfo entry?\n";
865 $v->{magicmap} // warn "WARNING: face '$k' has foreground colour.";
555 866
556 if (my $magicmap = $v->{magicmap}) { 867 delete @$v{qw(arc stem)}; # not used by the server
557 $magicmap =~ y/A-Z_\-/a-z/d; 868 }
558 $v->{magicmap} = $COLOR{$magicmap}; 869
870 print "processing resources...\n" if $VERBOSE;
871 my $enc = JSON::XS->new->utf8->canonical->relaxed;
872 while (my ($k, $v) = each %RESOURCE) {
873
874 if ($v->{meta} && $v->{meta}{datadir}) {
875 delete $RESOURCE{$k};
876
877 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
878
879 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
880 open my $fh, ">:raw", "$DATADIR/$k~"
881 or die "$DATADIR/$k~: $!";
882 syswrite $fh, $v->{data};
883 push @COMMIT, $k;
884
885 } else {
886 if ($v->{type} & 1) {
887 # prepend meta info
888
889 my $meta = $enc->encode ({
890 name => $k,
891 %{ $v->{meta} || {} },
892 });
893
894 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
559 } 895 }
896
897 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
560 } 898 }
899 }
900
901 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
902 scalar keys %FACEINFO,
903 scalar keys %ANIMINFO,
904 scalar keys %RESOURCE
905 if $VERBOSE;
561 906
562 open my $fh, ">:perlio", "$DATADIR/facedata~" 907 open my $fh, ">:perlio", "$DATADIR/facedata~"
563 or die "$DATADIR/facedata~: $!"; 908 or die "$DATADIR/facedata~: $!";
564 909
565 print $fh freeze { 910 print $fh nfreeze {
566 version => 2, 911 version => 2,
567 faceinfo => \%FACEINFO, 912 faceinfo => \%FACEINFO,
568 animinfo => \%ANIMINFO, 913 animinfo => \%ANIMINFO,
569 resource => \%RESOURCE, 914 resource => \%RESOURCE,
570 }; 915 };
571 }
572 916
917 }
918
919 print "committing files...\n" if $VERBOSE;
920
573 for (qw(archetypes facedata treasures)) { 921 for (qw(archetypes facedata treasures), @COMMIT) {
574 chmod 0644, "$DATADIR/$_~"; 922 chmod 0644, "$DATADIR/$_~";
575 rename "$DATADIR/$_~", "$DATADIR/$_" 923 rename "$DATADIR/$_~", "$DATADIR/$_"
576 or die "$DATADIR/$_: $!"; 924 or die "$DATADIR/$_: $!";
577 } 925 }
578 926

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines